// Grand Roads
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// RobFoxroads stuff
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////

#define TRUE	1
#define FALSE	0

#define MAP_WIDTH 106
#define MAP_HEIGHT 62

#define m(x,y) a[x+wide*y]

#define WIDTH 5.0    // one half the width of a road

struct VEC3D
{

	float
		x,
		y,
		z;
};

typedef struct VEC3D vec3d;

///////////////////////////////////////////////////////////////

struct COLOR
{

	unsigned char
		r,
		b,
		g,
		pad;
	
};

typedef struct COLOR color;

//////////////////////////////////////////////////////////////////////

struct POINT
{

	double
		global_x,
		global_z,
		global_y;
	
};

typedef struct POINT point;

//////////////////////////////////////////////////////////////////////

struct SIMPLE_POINT
{

	double
		x,
		z,
		y;


};

typedef struct SIMPLE_POINT simple_point;

//////////////////////////////////////////////////////////////////////

struct LINE
{
	point
		point_a,
		point_b;
};

typedef struct LINE line;

//////////////////////////////////////////////////////////////////////

struct QUAD
{
	point
		p,
		q,
		r,
		s;
};

typedef struct QUAD quad;

///////////////////////////////////////////////////////////////////////

struct ROAD
{
	int
		width,
		color,
		number_of_center_points,
		number_of_quads;

	point
		center_points[512];

	quad
		quads[512];
};

typedef struct ROAD road;

///////////////////////////////////////////////////////////////////////

struct BRIDGE
{
	vec3d
		end1,
		end2;

	int
		road,
		start_node,
		end_node,
		type;

	float
		max_leg_height;
};

typedef struct BRIDGE bridge;


