// ai_roads

#define MAX_ROUTE_LENGTH 100

struct LINK_DATA
{

	int
		cost;

	unsigned short int
		node			: 14,
		breaks		: 5;
};

typedef struct LINK_DATA link_data;

struct NODE_DATA
{

	unsigned int
		node						: 14,
		safe_radius				: 14,
		number_of_links		: 7,
		visited 					: 7,
		side_occupying 		: 2,
		side_aware				: 2,
		side_exploring			: 2;

	link_data
		*links;
};

typedef struct NODE_DATA node_data;

struct VEC3D
{

	float
		x,
		y,
		z;
};

typedef struct VEC3D vec3d;  


struct CONTOUR_PATH
{

	int
		from,
		to,
		type,
		count;

	float
		xmin,
		xmax,
		zmin,
		zmax;

	vec3d
		*points;
};

typedef struct CONTOUR_PATH contour_path;

